#!/usr/bin/ruby1.8

#TH 2010-10-02

include Math

unless ARGV[0]
	puts "Use  map2kap .map-file picture-file [scale] [Sounding Units] [Soundings Datum]
	[lat adj to wgs84 in seconds][long adj to wgs84 in seconds]
	If an argument is left out and others follows put 'unknown' as a place holder.
	It is alright to, for example, just give the scale and Soundinds Unit and nothing else."
	exit(false)
 end
 
mapfile = ARGV[0] 
pic = ARGV[1]
sc= ARGV[2] #scale
#pp= ARGV[3] 
un= ARGV[3] #sounding unit
sd= ARGV[4] # sounding Datum
dtm1= ARGV[5] # lat adj to wgs84
dtm2=ARGV[6]  # long ad to wgs 89


unless File.file? mapfile
	STDERR.print "Can't find mapfile'.Aborting!\n"
	exit(2)
end

unless mapfile=~ /\.map/
  puts "Invalid oz .map file"
  exit(1)
end


unless File.file? pic
	STDERR.print "Can't find picture file'.Aborting!\n"
	exit(2)
end
unless pic =~ /jpg|jpeg|png|PNG|JPG|JPEG|gif|GIF|pdf|PDF|tif|tiff|TIF|TIFF|bmp|BMP/
  puts "Invalid format for picture file"
  exit(1)
end


linenumber = 0

# Start processing the map file

filelines= File.readlines(mapfile)
 
 
 unless filelines[linenumber]=~ /OziExplorer Map Data File Version 2\./
   puts "Not a valid ozi mapfile"
   exit(2)
 end
 
 linenumber = linenumber +1
 chartTitle=filelines[linenumber]
 

 # Datum settings
 dtm =[0.0,0.0]
  
 linenumber = linenumber + 3

  if filelines[linenumber].split(",")[2].strip == "0.0000" and filelines[linenumber].split(",")[3].strip == "0.0000" 
 chartDatum = filelines[linenumber].split(",")[0]
 else
   chartDatum = "WGS84"
   dtm[0] = filelines[linenumber].split(",")[2]  #is this correct, try to find a sample file
   dtm[1] = filelines[linenumber].split(",")[3] 
 end
 
 if dtm1!=nil or dtm2!=nil
    chartDatum = "WGS84"
    dtm[0] = dtm1
    dtm[1] = dtm2
 end

 
while filelines[linenumber] !~/Projection/
   linenumber = linenumber +1
 end
 

 projection = filelines[linenumber].split(",")[1] 
 

 
 while filelines[linenumber] !~/Point/
   linenumber = linenumber +1
 end
 
# startref= linenumber

 
ref1 = filelines[linenumber ].split(",")
ref2 = filelines[linenumber +1 ].split(",")
ref3 = filelines[linenumber +2 ].split(",")
ref4 = filelines[linenumber +3 ].split(",")
ref5 = filelines[linenumber +4 ].split(",")
ref6 = filelines[linenumber +5 ].split(",")
ref7 = filelines[linenumber +6 ].split(",")
ref8 = filelines[linenumber +7 ].split(",")
ref9 = filelines[linenumber +8 ].split(",")
ref10 = filelines[linenumber +9 ].split(",")
ref11 = filelines[linenumber +10 ].split(",")
ref12 = filelines[linenumber +11].split(",")
ref13 = filelines[linenumber +12 ].split(",")
ref14 = filelines[linenumber +13].split(",")
ref15 = filelines[linenumber +14 ].split(",")
ref16 = filelines[linenumber +15 ].split(",")
ref17 = filelines[linenumber +16].split(",")
ref18 = filelines[linenumber +17].split(",")
ref19 = filelines[linenumber +18].split(",")
ref20 = filelines[linenumber +19].split(",")
ref21 = filelines[linenumber +20].split(",")
ref22 = filelines[linenumber +21].split(",")
ref23 = filelines[linenumber +22].split(",")
ref24 = filelines[linenumber +23].split(",")
ref25 = filelines[linenumber +24].split(",")
ref26 = filelines[linenumber +25].split(",")
ref27= filelines[linenumber +26].split(",")
ref28= filelines[linenumber +27].split(",")
ref29= filelines[linenumber +28].split(",")
ref30= filelines[linenumber +29].split(",")

  
 while filelines[linenumber] !~/MMPNUM/
   linenumber = linenumber +1
 end

    ply_number = filelines[linenumber].split(",")[1]
    ply1xy= filelines[linenumber + 1].split(",")
    ply2xy= filelines[linenumber + 2].split(",")
    ply3xy= filelines[linenumber + 3].split(",") 
    ply4xy= filelines[linenumber + 4].split(",")
      
   while filelines[linenumber] !~/MMPLL/
   linenumber = linenumber +1
   end  
 
    ply1longlat= filelines[linenumber ].split(",")
    ply2longlat= filelines[linenumber+1 ].split(",")
    ply3longlat= filelines[linenumber +2].split(",")
    ply4longlat= filelines[linenumber +3].split(",")
    

 ##########################################################################
 #Convert pic to tif
 
# pic.split(".")[1]= "gif"
 pic_gif ="#{pic.split(".")[0]}.gif"
 pic_tif ="#{pic.split(".")[0]}.tif"
 pic_kap ="#{pic.split(".")[0]}.kap"
 
system("convert #{pic} -font courier -fill red  -gravity SouthEast -pointsize 10 -annotate +3+18 'map2kap OpenCPN' #{pic_gif}")
system("convert #{pic_gif} -colors 127  #{pic_tif} ")
#  
##########################################################################
# Read relevant info in the tiffile
########################################################################## 

 
system("tiffinfo #{pic_tif} >tiffinfo.txt 2>/dev/zero")

tiff_w=0   #witdth tif
tiff_h=0	#height tif
tiff_res = 0 #resolotion
tiff_ifm=0 #IFM

 tiffinfo_lines = File.readlines("tiffinfo.txt")
 tiffinfo_lines.each do |f|
   if f =~ /Image W/
	 s= f.split(":")
	 tiff_w= s[1].split(" ")[0] 
	 tiff_h =s[2].strip
	end

 	if f =~ /Resolution:/ 
 	  tiff_res = f.split(":")[1].split(",")[0].strip
 	  end

    	if f =~ /Bits\/Sample/ 
 	  t = f.split(":")[1].lstrip
	  tiff_ifm =t.to_i-1
 	 end
	 
	 end 
	
  
   
 File.unlink "tiffinfo.txt"     #delete tmp file file.
 File.unlink pic_gif  if File.file? pic_gif 

#########################some helper routines################################################ 
 
 
 def sign(x)
   mult = 0
   if x == "W" or x == "S"
     mult = -1
   end
    if x == "E" or x == "N"
      mult = 1
    end
    
    return mult
  end
  

# sc = ((ply2longlat[3].to_f-ply3longlat[3].to_f) *60 * 1852)/ ((( ply3xy[2].to_f - ply4xy[2].to_f)/tiff_res.to_f )*0.0252)

  if projection == "Mercator"
  pp = (ply2longlat[3].to_f + ply3longlat[3].to_f)/2
  end

 if projection == "Transverse Mercator"
   pp = (ply2longlat[2].to_f-ply3longlat[2].to_f)/2
 end
#I have not yet seen an ozi tmerc file!

####################################################################

header = mapfile.gsub("map","hd")

open("#{header}","w") do |h|
 	  h.puts "! Converted Ozi Explorer .mapfile"
	   h.puts "! Converted with map2kap"
	  h.puts "VER/2.0"
	  h.puts "BSB/NA=#{chartTitle}"
	  h.puts "    NU=#{chartTitle}"
	  h.puts "    RA=#{tiff_w},#{tiff_h},DU=#{tiff_res}"
	  h.puts "KNP/SC=#{sc},GD=#{chartDatum},PR=#{projection.upcase!}"
	  h.puts "    PP=#{pp},PI=UNKNOWN,SP=UNKNOWN,SK=0.0"
	  h.puts "    UN=#{un},SD=#{sd},DX=000,DY=000"
	  t = Time.now
	  h.puts "CED/SE=,RE=,ED=#{t.strftime("%m/%d/%Y")}"
	  h.puts "REF/1,#{ply1xy[2].to_i},#{ply1xy[3].to_i},#{ply1longlat[3].strip},#{ply1longlat[2].strip}"
	  h.puts "REF/2,#{ply2xy[2.to_i]},#{ply2xy[3].to_i},#{ply2longlat[3].strip},#{ply2longlat[2].strip}"
	  h.puts "REF/3,#{ply3xy[2].to_i},#{ply3xy[3].to_i},#{ply3longlat[3].strip},#{ply3longlat[2].strip}"
	  h.puts "REF/4,#{ply4xy[2].to_i},#{ply4xy[3].to_i},#{ply3longlat[3].strip},#{ply4longlat[2].strip}"
	  
	  a = 5
	  [ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10,ref11,ref12,ref13,ref14,ref15,ref16,ref17,ref18,ref19,ref20,ref21,ref22,ref23,ref24,ref25,ref26,ref27,ref28,ref29,ref30].each {|geo|
	   break geo unless geo[3].to_i >0
	   h.puts "REF/#{a},#{geo[2].strip},#{geo[3].strip},#{(geo[6].to_i + geo[7].to_f/60) *sign(geo[8].strip)},#{(geo[9].to_i + geo[10].to_f/60) *sign(geo[11].strip)} "        
           a = a +1
	  }
# Native Ozi files shouldn't contain more than 4 PLY:s, unless converted from bsb. This can be improved with a loop as 
#the number of PLY:s is stated. Need a sample file.
	  h.puts "PLY/1,#{ply1longlat[3].strip},#{ply1longlat[2].strip}"
	  h.puts "PLY/2,#{ply2longlat[3].strip},#{ply2longlat[2].strip}"
	  h.puts "PLY/3,#{ply3longlat[3].strip},#{ply3longlat[2].strip}"
	  h.puts "PLY/4,#{ply4longlat[3].strip},#{ply4longlat[2].strip}"
	  h.puts "DTM/#{dtm[0]},#{dtm[1]}"
	  h.puts "IFM/#{tiff_ifm}"
end

system("tif2bsb -c 127 #{header}  #{ pic_tif } #{ pic_kap}")
system("rm *hd")
system("rm *tif")
